﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;
using NewTravelClientMVC.Models;
using NewTravelClientMVC.Models.Security;

namespace NewTravelClientMVC.Controllers
{
    public class OrdersController : Controller
    {

        [Authorize]
        public async Task<ActionResult> Index()
        {
            if (Security.getCurrentGuid() != null)
            {
                var userId = Security.getCurrentGuid().Value;
                var v = await GetOrdersByIdAsync(userId);                    
                return View(v);
            }
            System.Web.Security.FormsAuthentication.SignOut();
            return RedirectToAction("Login", "Account");           
        }

        //
        // GET: /Orders/Details/5

        public ActionResult Details(Guid id)
        {


            if (Security.getCurrentGuid() != null)
            {
                var userId = Security.getCurrentGuid().Value;
                var orderDetails = GetOrderDetailsByIdAsync(userId).Result;
                return View("_PartialDetail",orderDetails);
            }
            System.Web.Security.FormsAuthentication.SignOut();
            return RedirectToAction("Login", "Account");                       
        }

        //
        // GET: /Orders/Create

        public ActionResult Create()
        {
            return View();
        }

        //
        // POST: /Orders/Create

        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                if (Security.getCurrentUser() != null)
                {
                    var webUser = Security.getCurrentUser();
                    //var v = await GetOrdersByIdAsync(userId);
                    //return View(v);
                    
                    InsertCurrentOrder(webUser);

                    return RedirectToAction("Index");

                }
                System.Web.Security.FormsAuthentication.SignOut();
                return RedirectToAction("Login", "Account"); 

                

                // TODO: Add insert logic here


                
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Orders/Edit/5

        public ActionResult Edit(int id)
        {
            return View();
        }

        //
        // POST: /Orders/Edit/5

        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Orders/Delete/5

        public ActionResult Delete(int id)
        {
            return View();
        }

        //
        // POST: /Orders/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }



        public async Task<List<Order>> GetOrdersByIdAsync(Guid id)
        {

            using (HttpClient httpClient = new HttpClient())
            {
                var address = WebAddress.ActiveOrdersAddress + "/" + id.ToString();
                var v = await httpClient.GetStringAsync(address);
                return JsonConvert.DeserializeObject<List<Order>>(v);

                //"http://localhost:33504/Client/api/Products"
            }

        }

        public async Task<List<OrderDetail>> GetOrderDetailsByIdAsync(Guid id)
        {

            using (HttpClient httpClient = new HttpClient())
            {
                var address = WebAddress.OrderDetailsAddress + "/" + id.ToString();
                var v = await httpClient.GetStringAsync(address);
                return JsonConvert.DeserializeObject<List<OrderDetail>>(v);

                //"http://localhost:33504/Client/api/Products"
            }

        }

        public Task<HttpResponseMessage> InsertCurrentOrder(WebUser webUser)
        {
            var address = WebAddress.OrdersAddress;
            HttpClient client = new HttpClient();
            return client.PostAsJsonAsync<WebUser>(address, webUser);
        }
    }
}
