﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace NewTravelClientMVC.Models
{
    public class Employee
    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public Guid EmployeeId { get; set; }

        //public int EmployeeNumber { get; set; }

        [Required]
        [StringLength(50, ErrorMessage = "El {0} ha de ser més petit de {1} caràcters")]
        [Display(Name = "Nom")]
        public string Name { get; set; }

        [Required]
        [StringLength(70, ErrorMessage = "El {0} ha de ser més petit de {1} caràcters")]
        [Display(Name = "Cognoms")]
        public string Surname { get; set; }

        [Required]
        [StringLength(20, ErrorMessage = "El {0} ha de ser més petit de {1} caràcters")]
        [Display(Name = "N.I.F.")]
        public string Nif { get; set; }

        [DataType(DataType.Date)]
        [DisplayFormat(DataFormatString = "{0:dd/MM/yyyy}", ApplyFormatInEditMode = true)]
        [Display(Name = "D. Naixement")]
        public DateTime BirthDate { get; set; }

        [Required(ErrorMessage = "Cal introduir un correu electrònic")]
        [DataType(DataType.EmailAddress)]
        [Display(Name = "Correu electrònic")]
        public string Email { get; set; }

        [Required(ErrorMessage = "Cal introduir una contrasenya")]
        [StringLength(100, ErrorMessage = "La {0} ha de tenir com a mínim {2} caràcters de longitud i un màxim de {1}.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "Contrasenya")]
        [NotMapped]
        public string Password { get; set; }

        [Display(Name = "Actiu")]
        public bool ActiveUser { get; set; }



        public virtual Driver Driver { get; set; }

        [Display(Name = "Perfil")]
        public int Profile { get; set; }

        [NotMapped]
        public bool EditEmployee { get; set; }
    }
}