﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace NewTravelClientMVC.Models
{
    public class Product
    {
        [Key]
        public Guid ProductId { get; set; }

        [Required]
        [StringLength(100)]
        [Display(Name = "Nom del Producte")]
        public string Name { get; set; }

        [Required]
        [Display(Name = "Amplària (cm.) ")]
        public int Width { get; set; }

        [Required]
        [Display(Name = "Alçada (cm.)")]
        public int Height { get; set; }

        [Required]
        [Display(Name = "Profunditat (cm.)")]
        public int Depth { get; set; }

        [Required]
        [Display(Name = "Pes (Gr.)")]
        public int Weight { get; set; }

        [Required]
        [Display(Name = "Preu Unitari")]
        [DisplayFormat(DataFormatString = "{0:C2}")]
        public double UnitPrice { get; set; }

        [Display(Name = "Producte Refrigerat")]
        public bool Refrigerated { get; set; }

        [Display(Name = "Producte Actiu")]
        public bool Active { get; set; }

        //public virtual ICollection<Stock> Stocks { get; set; }
    }
}