﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace NewTravelClientMVC.Models
{
    public class Store
    {
        [Key]
        public Guid StoreId { get; set; }

        [Required(ErrorMessage = "Cal introduir l'adreça del Magatzem")]
        [StringLength(70, ErrorMessage = "El nom del magatzem no pot més gran de {1} caràcters.")]
        [Display(Name = "Nom")]
        public string Name { get; set; }


        [Required(ErrorMessage = "Cal introduir l'adreça del Magatzem")]
        [StringLength(100, ErrorMessage = "L'adreça no pot més gran de {1} caràcters.")]
        [Display(Name = "Adreça")]
        public string Address { get; set; }

        [Required(ErrorMessage = "Cal introduir la {0} del Magatzem")]
        [StringLength(30, ErrorMessage = "La longitud de la {0} no pot més gran de {1} caràcters.")]
        [Display(Name = "Ciutat")]
        public string City { get; set; }

        [Required(ErrorMessage = "Cal introduir el {0} del Magatzem")]
        [StringLength(30, ErrorMessage = "La longitud del {0} no pot més gran de {1} caràcters.")]
        [Display(Name = "País")]
        public string Country { get; set; }

        [Display(Name = "Latitud")]
        public string Latitude { get; set; }

        [Display(Name = "Longitud")]
        public string Longitude { get; set; }

        [Display(Name = "Magatzem Actiu")]
        public bool Active { get; set; }

        public virtual List<Stock> Stocks { get; set; }

        public virtual List<Vehicle> Vehicles { get; set; }
    }
    
}