﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Controllers
{
    public class AccountController : Controller
    {
         [HttpGet]
        [AllowAnonymous]
        //[ValidateAntiForgeryToken]
        [Authorize]
        public ActionResult Login(string returnUrl)
        {
           
            if (User.Identity.IsAuthenticated)
            {
                RedirectToAction("LogOut");
            }

            ViewBag.returnUrl = returnUrl;
            return View();
        }

        [HttpPost]
        [AllowAnonymous]
        [ValidateAntiForgeryToken]
        public ActionResult Login(WebUser model, string returnUrl)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    if (Membership.ValidateUser(model.UserName, model.Password))
                    {
                        FormsAuthentication.RedirectFromLoginPage(model.UserName, false);                        
                    }
                    ModelState.AddModelError("", "Nom d'Usuari o Contrasenya incorrecte");                                      
                }           
            }
            catch (Exception exception)
            {
                ViewBag.HasError = true;
                ModelState.AddModelError("", exception.Message);
            }      
            return View(model);

        }

        [AllowAnonymous]
        //[ValidateAntiForgeryToken]
        public ActionResult LogOff()
        {
            FormsAuthentication.SignOut();

            return RedirectToAction("Index", "Home", null);
        }       
    }

    
}
