﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Controllers
{
    [Authorize]
    public class DriverVehicleController : Controller
    {
        //
        // GET: /DriverVehicle/

        public async Task<ActionResult> Index()
        {
            var var = await GetDriverVehiclesAsync();
            return View(var);
        }

        public async Task<ActionResult> Create()
        {
            DriverVehicleModel dvm = new DriverVehicleModel();

            var vehicles = await GetVehiclesAsync();
            var filterVehicles = vehicles.Where(m=>m.Active==true).ToList();
            //ViewBag.Vehicles = filterVehicles;
            dvm.Vehicles = filterVehicles;

            var drivers = await GetEmployeesAsync();
            var filterDrivers = drivers.Where(m => m.Driver != null && m.Driver.Active == true
                && m.Profile > 2 && m.Profile < 8).ToList();

            dvm.Employees = filterDrivers;

            return View(dvm);
        }

        [HttpPost]
        public ActionResult Create(DriverVehicleAssignModel prova)
        {
            try
            {
                var responseQuery= GenerateDriverVehicle();
                return PartialView("_PartialDriverVehicle",responseQuery);
            }
            catch
            {
                return View();
            }
        }

        [HttpPost]
        public ActionResult Sergi()
        {
            //var ss = 55;
            return View();
        }


        #region Call Web APIS

        public async Task<List<DriverVehicle>> GetDriverVehiclesAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<DriverVehicle>>(
                 await httpClient.GetStringAsync(WebAddress.DriverVehiclesAddress));
            }
        }

        public async Task<List<Vehicle>> GetVehiclesAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<Vehicle>>(
                 await httpClient.GetStringAsync(WebAddress.VehicleAddress));
            }
        }

        public async Task<List<Employee>> GetEmployeesAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                var response = await httpClient.GetStringAsync(WebAddress.EmployeesAddress);
                return JsonConvert.DeserializeObject<List<Employee>>(response);
            }
        }

        public DriverVehicleAssignModel GenerateDriverVehicle()
        {
            DriverVehicle dv = new DriverVehicle();
            var address = WebAddress.DriverVehiclesAddress;
            HttpClient client = new HttpClient();
            var response = client.PostAsJsonAsync<DriverVehicle>(address, dv).Result;

            if (response.IsSuccessStatusCode)
            {
                var responseQuery = response.Content.ReadAsAsync<DriverVehicleAssignModel>().Result;
                return responseQuery;
            }
            return null;
        }

        #endregion
    }
}
