﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Controllers
{
    [Authorize]
    public class OrdersController : Controller
    {

        public async Task<ActionResult> Index()
        {            
            return View(await GetOrdersAsync());
        }

        public async Task<ActionResult> Details(Guid id)
        {
            if (Request.IsAjaxRequest())
            {
                var detail = await GetOrderDetailsAsync(id);
                return PartialView(detail);
            }
            return View();
        }

        public ActionResult Create()
        {


            //Order or = new Order();
            //or.OrderId = Guid.NewGuid();
            //or.TotalAmount = 25.3;
            //or.CustomerId = Guid.NewGuid();

            //HttpClient client = new HttpClient();
            //var task = client.PostAsJsonAsync<Order>
            // ("http://localhost:33504/Admin/api/AdOrders",or);
            //         //new CustomerDetail() { // Set properties });


            return View();
        }



        public ActionResult Delete(Guid id)
        {
            
            DeleteOrderDetailById(id);
            return RedirectToAction("Index");
        }


        #region Call Web API

        public async Task<List<Order>> GetOrdersAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<Order>>(
                    await httpClient.GetStringAsync(WebAddress.OrdersAddress));
            }
        }



        public async Task<Order> GetOrderDetailsAsync(Guid id)
        {
            using (HttpClient httpClient = new HttpClient())
            {
                var address = WebAddress.OrdersAddress + "/" + id.ToString();
                return JsonConvert.DeserializeObject<Order>(
                    await httpClient.GetStringAsync(address));
            }
        }

        public HttpResponseMessage DeleteOrderDetailById(Guid id)
        {
            using (HttpClient httpClient = new HttpClient())
            {
                var address = WebAddress.OrdersAddress + "/" + id.ToString();
                HttpClient client = new HttpClient();
                return client.DeleteAsync(address).Result;
            }
        }

        #endregion
    }
}
