﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Controllers
{
    [Authorize]
    public class StocksController : Controller
    {
        public async Task<ActionResult> Index()
        {
            var v = await GetStocksAsync();
            return View(v);
        }

        //
        // GET: /Stocks/Details/5

        public ActionResult Details(int id)
        {
            return View();
        }

        //
        // GET: /Stocks/Create

        public async Task<ActionResult> Create()
        {

            var products = await GetProductsAsync();
                //_db.Products.Where(m => m.Active == true).ToList();
            var stores = await GeStoresAsync();
                //_db.Stores.Where(m => m.Active == true).ToList();
            ViewBag.ProductId = new SelectList(products, "ProductId", "Name");
            ViewBag.StoreId = new SelectList(stores, "StoreId", "Name");
            return View();
            //return View();
        }

        //
        // POST: /Stocks/Create

        [HttpPost]
        public ActionResult Create(Stock stock)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    InsertNewStock(stock);
                }

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
            //return View();

            //if (ModelState.IsValid)
            //{
            //    var st = _db.Stocks.Where(m => m.StoreId == stock.StoreId &&
            //        m.ProductId == stock.ProductId).FirstOrDefault();
            //    if (st == null)
            //        _db.Stocks.Add(stock);
            //    else
            //    {
            //        ((Stock)st).Items += stock.Items;
            //        _db.Entry(st).State = System.Data.Entity.EntityState.Modified;
            //    }
            //    _db.SaveChanges();
            //    return RedirectToAction("Index");
            //}
            //return View(stock);
        }

        //
        // GET: /Stocks/Edit/5

        public ActionResult Edit(int id)
        {
            return View();
        }

        //
        // POST: /Stocks/Edit/5

        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Stocks/Delete/5

        public ActionResult Delete(int id)
        {
            return View();
        }

        //
        // POST: /Stocks/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }


        public async Task<List<Stock>> GetStocksAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<Stock>>(
                 await httpClient.GetStringAsync(WebAddress.StocksAddress));
            }
        }

        public HttpResponseMessage InsertNewStock(Stock stock)
        {
            var address = WebAddress.StocksAddress;
            HttpClient client = new HttpClient();
            return client.PostAsJsonAsync<Stock>(address, stock).Result;
        }



        public List<Product> GetProducts()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<Product>>(
                 httpClient.GetStringAsync(WebAddress.ProductAddress).Result);
            }
        }

        public async Task<List<Product>> GetProductsAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<Product>>(
                 await httpClient.GetStringAsync(WebAddress.ProductAddress));
            }
        }

        public async Task<List<Store>> GeStoresAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                var response = await httpClient.GetStringAsync(WebAddress.StoreAddress);
                return JsonConvert.DeserializeObject<List<Store>>(response);
            }
        }
    }
}
