﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Controllers
{
    [Authorize]
    public class VehicleCategoriesController : Controller
    {
  
        public async Task<ActionResult> Index()
        {
            var var = await GetVehicleCategoriesAsync();
            return View(var);
        }

        public ActionResult Details(int id)
        {
            return View();
        }

        //
        // GET: /VehicleCategories/Create

        public ActionResult Create()
        {

            return View();
        }

        //
        // POST: /VehicleCategories/Create

        [HttpPost]
        public ActionResult Create(VehicleCategory vehicleCategory)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    InsertNewVehicleCategory(vehicleCategory);
                    return RedirectToAction("Index");
                }
            }
            catch
            {
                return View();
            }
            return View();
        }

        //
        // GET: /VehicleCategories/Edit/5

        public async Task<ActionResult> Edit(Guid id)
        {
            var vehCategories = await GetVehicleCategoryByIdAsync(id);
            return View(vehCategories);
        }

        //
        // POST: /VehicleCategories/Edit/5

        [HttpPost]
        public ActionResult Edit(Guid id, VehicleCategory vehicleCategory)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    UpdateVehicleCategoryById(vehicleCategory);
                    return RedirectToAction("Index");
                }
            }
            catch
            {
                return View();
            }
            return View();
        }

        //
        // GET: /VehicleCategories/Delete/5

        public ActionResult Delete(int id)
        {
            return View();
        }

        //
        // POST: /VehicleCategories/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }



        public async Task<List<VehicleCategory>> GetVehicleCategoriesAsync()
        {
            using (HttpClient httpClient = new HttpClient())
            {
                return JsonConvert.DeserializeObject<List<VehicleCategory>>(
                 await httpClient.GetStringAsync(WebAddress.VehicleCategoryAddress));
            }
        }
        public async Task<VehicleCategory> GetVehicleCategoryByIdAsync(Guid id)
        {
            using (HttpClient httpClient = new HttpClient())
            {
                var address = WebAddress.VehicleCategoryAddress + "/" + id.ToString();
                var JsonProducte = await httpClient.GetStringAsync(address);
                return JsonConvert.DeserializeObject<VehicleCategory>(JsonProducte);
            }
        }

        public HttpResponseMessage InsertNewVehicleCategory(VehicleCategory vehicleCategory)
        {
            var address = WebAddress.VehicleCategoryAddress;
            HttpClient client = new HttpClient();
            return client.PostAsJsonAsync<VehicleCategory>(address, vehicleCategory).Result;
        }

        public HttpResponseMessage UpdateVehicleCategoryById(VehicleCategory vehicleCategory)
        {
            var address = WebAddress.VehicleCategoryAddress + "/" + vehicleCategory.VehicleCategoryId.ToString();
            HttpClient client = new HttpClient();
            return client.PutAsJsonAsync<VehicleCategory>(address, vehicleCategory).Result;

        }




    }
}
