﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace NewTravelAdminMVC.Models
{
    public class Order
    {
        [Key]
        public Guid OrderId { get; set; }

        public Guid CustomerId { get; set; }
        public virtual Customer Customer { get; set; }

        [Display(Name = "Data Comanda")]
        public DateTime Date { get; set; }

        [Display(Name = "Data d'entrega Estimada")]
        public DateTime? EstimatedDelivery { get; set; }

        [Display(Name = "Data d'entrega")]
        public DateTime? Delivery { get; set; }

        [DisplayFormatAttribute(DataFormatString = "{0:C}", ApplyFormatInEditMode = true)]
        [Display(Name = "Import Total")]
        public double TotalAmount { get; set; }

        public virtual List<OrderDetail> OrderDetails { get; set; }

        public Guid? StoreId { get; set; }
        public Store Store { get; set; }
    }
}