﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Caching;
using System.Web.Security;
using NewTravelAdminMVC.Models;

namespace NewTravelAdminMVC.Models.Security
{
    public class  CustomRoleProvider : RoleProvider
    {
        
        int _cacheTimeoutInMinutes = 30;

        public override void AddUsersToRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override void CreateRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
        {
            throw new NotImplementedException();
        }

        public override string[] FindUsersInRole(string roleName, string usernameToMatch)
        {
            throw new NotImplementedException();
        }

        public override string[] GetAllRoles()
        {
            throw new NotImplementedException();
        }
        
        public override string[] GetRolesForUser(string username)
        {

            if (!HttpContext.Current.User.Identity.IsAuthenticated)
                return null;

            var cacheKey = string.Format("UserRoles_{0}", username);
            if (HttpRuntime.Cache[cacheKey] != null)
                return (string[])HttpRuntime.Cache[cacheKey];
          
            var userKey = string.Format("WebUser_{0}", username);
            List<string> roles = new List<string>();
            if (HttpRuntime.Cache[userKey] != null)
            {
                var webUser = (WebUser) HttpRuntime.Cache[userKey];
                roles = Security.CreateRoleStringFromInt(webUser.Roles);
                var userRoles = roles.ToArray();

                HttpRuntime.Cache.Insert(userKey, webUser, null, DateTime.Now.AddMinutes(_cacheTimeoutInMinutes), Cache.NoSlidingExpiration);    
            }
            if (roles.Count > 0)
                HttpRuntime.Cache.Insert(cacheKey, roles.ToArray(), null, DateTime.Now.AddMinutes(_cacheTimeoutInMinutes), Cache.NoSlidingExpiration);
           
            return roles.ToArray();

        }

        public override string[] GetUsersInRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override bool IsUserInRole(string username, string roleName)
        {
            var userRoles = GetRolesForUser(username);
            return userRoles.Contains(roleName);            
        }

        public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override bool RoleExists(string roleName)
        {
            throw new NotImplementedException();
        }
        
    }
}