﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace NewTravelAdminMVC.Models.Security
{

    public class Security
    {
        [Flags]
        public enum Roles
        {
            None = 0,
            User = 1,
            Office = 2,
            Driver = 4,
            Administrator = 8
        }

        public static List<string> CreateRoleStringFromInt(int value)
        {
            List<string> RoleList = new List<string>();
            var binaryValue = Convert.ToString(value, 2);
            int count = -1;

            for (int i = binaryValue.Length - 1; i >= 0; i--)
            {
                count++;
                int bitValue = int.Parse(binaryValue[i].ToString());
                if (bitValue == 1)
                {
                    int valor = (int)System.Math.Pow(2, count);

                    string role = Enum.GetName(typeof(Roles), valor);
                    RoleList.Add(role);
                }
            }
            return RoleList;
        }





        public static Guid? getCurrentGuid()
        {
            if (HttpContext.Current.Session["userId"] != null)
                return (Guid)HttpContext.Current.Session["userId"];
            return null;
        }
    }
}