﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace NewTravelAdminMVC.Models
{

    [Flags]
    public enum SecurityProfile
    {
        [Description ("Cap Perfil")]
        None = 0,

        [Description ("Usuari del Web")]
        User = 1,

        [Description ("Oficines")]
        Office = 2,

        [Description("Conductor")]
        Driver = 4,

        [Description("Oficines i Conductor")]
        All = Office | Driver,

        [Description("Administrador")]
        Administrator = 8
    }


    public class SecurityProfiles
    {
        public static SelectList getSecurityProfiles()
        {
            List<object> list = new List<object>();
            foreach (SecurityProfile emp in Enum.GetValues(typeof(SecurityProfile)))
                list.Add(new { Value = emp, intValue = (int)emp, Text = emp.ToString(), Description = emp.Description() });
            return new SelectList(list, "intValue", "Description");
        }

        public static SelectList getSecurityProfiles(int valor)
        {
            List<object> list = new List<object>();
            foreach (SecurityProfile emp in Enum.GetValues(typeof(SecurityProfile)))            
                list.Add(new { Value = emp, intValue = (int)emp, Text = emp.ToString(), Description = emp.Description() });           
            return new SelectList(list, "intValue", "Description", valor);
        }


        public static string getDescription(int value)
        {
            return ((SecurityProfile)value).Description();
        }
    }
}