﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace NewTravelAdminMVC.Models
{
    public class TransportOrder
    {
        [Key]
        public Guid TranportOrderId { get; set; }

        [Required]
        public Guid OrderId { get; set; }
        [ForeignKey("OrderId")]
        public Order Order { get; set; }

        [Required]
        public int OrderTranportType { get; set; }

        public virtual List<OrderDetail> OrderDetails { get; set; }

        public DateTime? EstimatedDate { get; set; }
        public DateTime? DeliveryDate { get; set; }

        [NotMapped]
        public int Weight { get; set; }
        //public int Alt { get; set; }
        //public int Ample { get; set; }
        //public int Profund { get; set; }
        [NotMapped]
        public int Volume { get; set; }

        [NotMapped]
        public virtual List<Vehicle> CapableVehicles { get; set; }

        public Guid TransportRouteId { get; set; }
        [ForeignKey("TransportRouteId")]
        public TransportRoute TransportRoute { get; set; }

        [NotMapped]
        public virtual List<StoreRoute> StoreRoutes { get; set; }

        [NotMapped]
        public virtual List<TimeToDestination> TimeToDestinations { get; set; }

        public bool Assigned { get; set; }


    }
}