﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace NewTravelAdminMVC.Models
{
    public class Vehicle
    {
        public Guid VehicleId { get; set; }

        [Display(Name = "Marca")]
        [StringLength(50, ErrorMessage = "La marca no pot tenir més de 50 caracters")]
        public string Brand { get; set; }

        [StringLength(50, ErrorMessage = "El model no pot tenir més de 50 caracters")]
        public string Model { get; set; }

        [Display(Name = "Matrícula")]
        [StringLength(20, ErrorMessage = "La matrícula no pot tenir més de 50 caracters")]
        public string Plate { get; set; }

        [Display(Name = "Vehicle Refrigerat")]
        public bool Refrigerated { get; set; }

        [Display(Name = "Actiu")]
        public bool Active { get; set; }

        [Display(Name = "Amplada Màxima")]
        public int MaxWidth { get; set; }

        [Display(Name = "Alçada Màxima")]
        public int MaxHeight { get; set; }

        [Display(Name = "Profunditat Màxima")]
        public int MaxDepth { get; set; }

        [Display(Name = "Pes Màxim")]
        public int MaxWeight { get; set; }

        [Display(Name = "Tipus de Vehicle")]
        public Guid VehicleCategoryId { get; set; }
        [ForeignKey("VehicleCategoryId")]
        public virtual VehicleCategory VehicleCategory { get; set; }

        [Display(Name = "Magatzem")]
        public Guid StoreId { get; set; }
        [ForeignKey("StoreId")]
        public virtual Store Store { get; set; }


        [NotMapped]
        public bool Assigned { get; set; }
    }
}