﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdCustomersController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Customer> Get()
        {                        
            return _db.Customers.ToList();
        }

        public Customer Get(Guid id)
        {
            var cust = _db.Customers.Find(id);
            return cust;
        }

        public void Post([FromBody]object value)
        {
            var customer = JsonConvert.DeserializeObject<Customer>(value.ToString());
            customer.CustomerId = Guid.NewGuid();
            _db.Customers.Add(customer);
            _db.SaveChanges();            
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modCustomer = JsonConvert.DeserializeObject<Customer>(value.ToString());
            var customer = _db.Customers.Find(id);
            _db.Entry(customer).CurrentValues.SetValues(modCustomer);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
