﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdDriverVehiclesController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();
 
        public IEnumerable<DriverVehicle> Get()
        {
            return _db.DriverVehicles.Include("Driver").Include("Vehicle").OrderByDescending(m=>m.Date).ToList();
        }

        public DriverVehicleAssignModel Post([FromBody]object value)
        {
            DriverVehicleAssignModel dvm;
            DateTime dt = DateTime.Now.Date;
            var vari = _db.DriverVehicles.Include("Driver.Employee")
                                          .Include("Vehicle")
                                          .Where(m => m.Date == dt)
                                          .OrderByDescending(m=>m.Date).ToList();

            if (vari == null || vari.Count == 0)
            {
                dvm = DriverVehicle.GenerateDriverVehicleList(_db);
                //vari = _db.DriverVehicles.Include("Driver.Employee").Include("Vehicle").Where(m => m.Date == dt).ToList();
            }
            else
            {
                dvm = new DriverVehicleAssignModel();
                dvm.DriverVehicles = vari;
            }
            return dvm;
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
