﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdEmployeesController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Employee> Get()
        {
            var emp = _db.Employees.Include("Driver").Include("Driver.VehicleCategories") .ToList();
            return emp;
        }

        public Employee Get(Guid id)
        {
            var emp = _db.Employees.Include("Driver").Include("Driver.VehicleCategories").Where(m => m.EmployeeId == id).FirstOrDefault();
            return emp;
        }

        public void Post([FromBody]object value)
        {
            var employee = JsonConvert.DeserializeObject<Employee>(value.ToString());
            employee.EmployeeId = Guid.NewGuid();                        
            employee.Driver.DriverId = employee.EmployeeId;

            List<VehicleCategory> dv = employee.Driver.VehicleCategories.ToList();
            foreach (var v in employee.Driver.VehicleCategories.ToList())
            {
                employee.Driver.VehicleCategories.Remove(v);
            }

            _db.Employees.Add(employee);
            _db.SaveChanges();

            foreach (var v in dv)
            {
                if (employee.Driver.VehicleCategories == null)
                    employee.Driver.VehicleCategories = new List<VehicleCategory>();
                employee.Driver.VehicleCategories.Add(v);
            }
            Employee.updateDriver(employee);
            Employee.UpdateVehicleCategories(employee);
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modEmployee = JsonConvert.DeserializeObject<Employee>(value.ToString());

            var employee = _db.Employees.Find(id);
            _db.Entry(employee).CurrentValues.SetValues(modEmployee);
            _db.SaveChanges();
                                  
            Employee.updateDriver(modEmployee);
            Employee.UpdateVehicleCategories(modEmployee);
        }

        //private static void UpdateVehicleCategories(Employee employee)
        //{
        //    List<Guid> guids = new List<Guid>();

        //    if (employee.Driver.VehicleCategories != null)
        //    {
        //        foreach (var v in employee.Driver.VehicleCategories)
        //            guids.Add(v.VehicleCategoryId);
        //    }

        //    SqlConnection oConn = new SqlConnection(
        //     ConfigurationManager.ConnectionStrings["DefaultConnection1"].ConnectionString);

        //    SqlCommand oComm = new SqlCommand(
        //        "DELETE FROM DriverCategories WHERE DriverId = @DriverId", oConn);

        //    oComm.Parameters.AddWithValue("@DriverId", employee.EmployeeId);
        //    oConn.Open();
        //    oComm.ExecuteNonQuery();

        //    if (employee.Driver.VehicleCategories != null && employee.Profile > 2 && employee.Profile < 8) 
        //    {
        //        oComm.Parameters.Clear();
        //        oComm.CommandText = "INSERT INTO DriverCategories VALUES (@DriverId, @VehicleCategoryId)";
        //        oComm.Parameters.AddWithValue("@DriverId", employee.EmployeeId);
        //        foreach (Guid id in guids)
        //        {
        //            if (!oComm.Parameters.Contains("@vehicleCategoryId"))
        //                oComm.Parameters.AddWithValue("@vehicleCategoryId", id);
        //            else
        //                oComm.Parameters["@vehicleCategoryId"].Value = id;
        //            oComm.ExecuteNonQuery();
        //        }
        //    }
        //    oConn.Close();

        //}

        //public static void updateDriver(Employee employee)
        //{
        //    using (SqlConnection oConn = new SqlConnection(
        //        ConfigurationManager.ConnectionStrings["DefaultConnection1"].ConnectionString))
        //    {
        //        try
        //        {
        //            SqlCommand oComm = new SqlCommand(
        //                "DELETE FROM Drivers WHERE DriverId =@DriverId", oConn);
        //            oComm.Parameters.AddWithValue("@DriverId", employee.EmployeeId);
        //            oConn.Open();
        //            oComm.ExecuteNonQuery();

        //            if (employee.Profile > 2 && employee.Profile < 8)
        //            {
        //                string licenseId = "";
        //                if (employee.Driver != null && employee.Driver.LicenseId != null)
        //                    licenseId = employee.Driver.LicenseId;

        //                bool activeDriver = false;
        //                if (employee.Driver != null && employee.Driver.Active == true) //&& employee.Driver.Active != null
        //                    activeDriver = true;

        //                oComm.Parameters.Clear();
        //                oComm.CommandText = "INSERT INTO Drivers(DriverId, LicenseID, Active) " +
        //                    "VALUES (@DriverId, @LicenseId, @Active)";
        //                oComm.Parameters.AddWithValue("@DriverId", employee.EmployeeId);
        //                oComm.Parameters.AddWithValue("@LicenseId", licenseId);
        //                oComm.Parameters.AddWithValue("@Active", activeDriver);
        //                oComm.ExecuteNonQuery();
        //            }
        //            oConn.Close();
        //        }
        //        catch (Exception ex)
        //        {
        //            var ss = ex.Message;
        //        }

        //    }

        //}

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
