﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdOrdersController : ApiController
    {

        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Order> Get()
        {
            return _db.Orders.ToList();
        }

        public Order Get(Guid id)
        {
            var order = _db.Orders.Include("OrderDetails").Where(m => m.OrderId == id).FirstOrDefault();
            return order;            
        }

        public void Post([FromBody]object value)
        {
            var order = JsonConvert.DeserializeObject<Order>(value.ToString());
            order.OrderId = Guid.NewGuid();
            _db.Orders.Add(order);
            _db.SaveChanges();
        }

        public void Delete(Guid id)
        {
            var dd = _db.Orders.Include("OrderDetails").Where(m => m.OrderId == id).FirstOrDefault();
            _db.Orders.Remove(dd);
            _db.SaveChanges();           
        }


        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
