﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdProductsController : ApiController
    {

        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Product> Get()
        {
            return _db.Products.ToList();
        }

        public Product Get(Guid id)
        {
            var product = _db.Products.Find(id);
            return product;
        }

        public void Post([FromBody]object value)
        {
            var product = JsonConvert.DeserializeObject<Product>(value.ToString());
            product.ProductId = Guid.NewGuid();
            _db.Products.Add(product);
            _db.SaveChanges();
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modProduct = JsonConvert.DeserializeObject<Product>(value.ToString());
            var product = _db.Products.Find(id);
            _db.Entry(product).CurrentValues.SetValues(modProduct);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
