﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NewTravelWebAPI.Models;
using System.Configuration;
using Newtonsoft.Json;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdStoresController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Store> Get()
        {          
            var stores = _db.Stores.ToList();
            return stores;           
        }

        public Store Get(Guid id)
        {
            var store = _db.Stores.Where(m => m.StoreId == id).FirstOrDefault();
            return store;
        }

        public void Post([FromBody]object value)
        {
            var store = JsonConvert.DeserializeObject<Store>(value.ToString());
            store.StoreId = Guid.NewGuid();
            _db.Stores.Add(store);
            _db.SaveChanges();
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modStore = JsonConvert.DeserializeObject<Store>(value.ToString());
            var store = _db.Stores.Find(id);
            _db.Entry(store).CurrentValues.SetValues(modStore);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
