﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdVehicleCategoriesController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<VehicleCategory> Get()
        {
            return _db.VehicleCategories.ToList();
        }

        public VehicleCategory Get(Guid id)
        {
            var vhcat = _db.VehicleCategories.Find(id);
            return vhcat;
        }

        public void Post([FromBody]object value)
        {
            var vehicleCategory = JsonConvert.DeserializeObject<VehicleCategory>(value.ToString());
            vehicleCategory.VehicleCategoryId = Guid.NewGuid();
            _db.VehicleCategories.Add(vehicleCategory);
            _db.SaveChanges();
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modVehicleCategory = JsonConvert.DeserializeObject<VehicleCategory>(value.ToString());
            var vehicleCategory = _db.VehicleCategories.Find(id);
            _db.Entry(vehicleCategory).CurrentValues.SetValues(modVehicleCategory);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
