﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Admin.Controllers
{
    public class AdVehiclesController : ApiController
    {

        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<Vehicle> Get()
        {
            return _db.Vehicles.ToList();           
        }

        public Vehicle Get(Guid id)
        {
            var vehicle = _db.Vehicles.Find(id);
            return vehicle;
        }

        public void Post([FromBody]object value)
        {
            var vehicle = JsonConvert.DeserializeObject<Vehicle>(value.ToString());
            vehicle.VehicleId = Guid.NewGuid();
            _db.Vehicles.Add(vehicle);
            _db.SaveChanges();
        }

        public void Put(Guid id, [FromBody]object value)
        {
            var modVehicle = JsonConvert.DeserializeObject<Vehicle>(value.ToString());
            var vehicle = _db.Vehicles.Find(id);
            _db.Entry(vehicle).CurrentValues.SetValues(modVehicle);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
