﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Client.Controllers
{
    public class CliProductsController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();
        public IEnumerable<CartModel> Get()
        {
            var products = _db.Stocks.Include("Product").Where(m => m.product.Active == true)
              .GroupBy(x => new { x.ProductId, x.product.Name, x.product.UnitPrice })
              .Select(x => new CartModel
              {
                  ProductId = x.Key.ProductId,
                  Name = x.Key.Name,
                  UnitPrice = x.Key.UnitPrice,
                  QuantityMax = x.Sum(p => p.Items)
              }).ToList();
            return products;  
        }

        public CartModel Get(Guid id)
        {
            var product = _db.Stocks.Include("Product")
                .Where(m => m.product.Active == true && m.ProductId == id)
                .GroupBy(x => new { x.ProductId, x.product.Name, x.product.UnitPrice })
                .Select(x => new CartModel
                {
                    ProductId = x.Key.ProductId,
                    Name = x.Key.Name,
                    UnitPrice = x.Key.UnitPrice,
                    QuantityMax = x.Sum(p => p.Items)
                }).FirstOrDefault();

            return product;
        }

        public void Delete(Guid id)
        {
            var cart = _db.Carts.Find(id);
            _db.Carts.Remove(cart);
            _db.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
