﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Client.Controllers
{
    public class HistoricalOrdersController : ApiController
    {

        DbContextAPI _db = new DbContextAPI();



        public IEnumerable<OrdersAPI> Get(Guid id)
        {
           // return _db.Orders.Where(m=>m.CustomerId == id && m.Delivery==null).OrderBy(m=>m.Date).ToList();

            var v = _db.Orders.Where(m => m.CustomerId == id && m.Delivery != null).OrderBy(m => m.Date)
                .Select(m => new OrdersAPI()
                {
                    CustomerId = m.CustomerId,
                    Date = m.Date,
                    OrderId = m.OrderId,
                    EstimatedDelivery = m.EstimatedDelivery,
                    Delivery = m.Delivery,
                    TotalAmount = m.TotalAmount
                }).ToList();

            return v;

        }

        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }

    }
}
