﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Client.Controllers
{
    public class OrderDetailController : ApiController
    {
        DbContextAPI _db = new DbContextAPI();

        public IEnumerable<OrderDetailAPI> Get(Guid id)
        {
            
            var v = _db.OrderDetails.Include("Product")
                .Where(m => m.OrderId == id)
                .Select(m=> new OrderDetailAPI {
                    OrderDetailId = m.OrderDetailId,
                    OrderId = m.OrderId,
                    ProductId = m.ProductId,
                    ProductName = m.Product.Name,
                    Quantity = m.Quantity,
                    UnitPrice = m.UnitPrice})
                .ToList();

            return v;
                
                //Classes.GetOrderDetailByOrder(id);
        }


        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }

    public class OrderDetailAPI
    {
        public Guid OrderDetailId { get; set; }
        public Guid OrderId { get; set; }
        public Guid ProductId { get; set; }
        public string ProductName { get; set; }
        public int Quantity { get; set; }
        public double UnitPrice { get; set; }
    }
}
