﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Areas.Client.Controllers
{
    public class OrdersController : ApiController
    {

        DbContextAPI _db = new DbContextAPI();


        public IEnumerable<Order> Get(Guid id)
        {

            return null;
        }





        public void Post([FromBody]object value)
        {
            WebUser webClient = JsonConvert.DeserializeObject<WebUser>(value.ToString());
            
            
            
            var carts = _db.Carts.Where(m => m.CustomerId == webClient.UserId).ToList();

            if (carts.Count > 0)
            {
                Order or = new Order();

                or.OrderId = Guid.NewGuid();
                or.CustomerId = webClient.UserId.Value;
                or.Date = DateTime.Now;
                or.Delivery = null;
                or.EstimatedDelivery = null;
                or.StoreId = null;
                or.TotalAmount = 0;
                or.OrderDetails = new List<OrderDetail>();

                foreach (var cart in carts.ToList())
                {
                    OrderDetail od = new OrderDetail();
                    od.OrderDetailId = Guid.NewGuid();
                    od.OrderId = or.OrderId;
                    od.ProductId = cart.ProductId;
                    od.Quantity = cart.Quantity;
                    od.StoreId = null;
                    od.UnitPrice = cart.UnitPrice;

                    or.TotalAmount += od.Quantity * od.UnitPrice;

                    or.OrderDetails.Add(od);

                    _db.Carts.Remove(cart);
                }

                

                _db.Orders.Add(or);
                _db.SaveChanges();
            }


        }



        protected override void Dispose(bool disposing)
        {
            _db.Dispose();
            base.Dispose(disposing);
        }
    }
}
