﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;
using NewTravelWebAPI.Models;

namespace NewTravelWebAPI.Models
{

    public class Route
    {

        int VariableTempsDistancia = 200;
        int AverageTimeStop = 5;
        int InitMinutes = 480;

        DbContextAPI _db = new DbContextAPI();
        List<TransportOrder> TransportOrders = new List<TransportOrder>();
        List<TransportRoute> TransportRoutes = null;

        List<string> Errors = new List<string>();


        public List <TransportRoute> Inici(int Save)
        {

            // 1.   Recorrem totes les comandes i per cada comanda mirem els articles
            //      Si una comanda te articles de 2 tipus (normal i refrigerats) la dividim en dues comandes
            //      A cada comanda o nova comanda se li dirà Ordre de Transport.            

            GenerateTransportOrders(TransportOrders);



            // 2.   Per Cada TransportOrder trobar els Magatzems per distància més propers
            //      Aquest pas no és necessari però ajuda posteriorment a fer més efectiva la iteració
            //      També comprovem si el magatzem disposa de tots el productes del Detall del TransporOrder
            //      i amb la quantitat necessària. Si disposa el marca com a true, sinó fals.

            GenerateStoreRoutes(TransportOrders);

            
            // 3.   Per Cada TransportOrder obtenir els vehicles que la poden portar
            //      Igual que el cas anterior aquesta verificació és teòrica i de depèn de la 
            //      càrrega que porta prèviament, però si amb el vehicle buit no la pot portar
            //      tampot no la podrà porta ple.

            GenerateCapablesVehicles(TransportOrders);


            // 4.   Per a cada magatzem trobem els vehicles disponibles
            //      I creem Rutes de Transport
            //      Obtenim els DriverVehicles Disponibles per avui
            
            TransportRoutes = CreateTransportRoutes ();
           
            
         

            // 5.   Calcular per a cada TransportOrder Totes les TransportRoutes(Vehicles) que ho poden portar
            //      I en cas que ho puguin portar, el temps que trigaran en funció de la distància 
            //      i el transports que hagin de fer prèviament

            CalculateOrdersRoutes(TransportOrders, TransportRoutes);

                       List<Stock> Stocks = new List<Stock>();

            
            //6.      Aquest mètode sí que és important Calcula la distància i el temps a arribar en el vehicles disponibles
            //      i capacitats, ho fa en funció del temps i de les assignacions prèvies.

            
            AssignRoutesToOrders(Stocks);

                       
            if (Save==1)
            {

                foreach (var t in TransportRoutes)
                {
                    _db.TransportRoutes.Add(t);
                    _db.SaveChanges();
                }
            }



            return TransportRoutes;

        }

        private void provaCalculTemps(List<DriverVehicle> tempVehicles)
        {
            //DateTime dt = DateTime.Now.Date;
            //var tempVehicles = _db.DriversVehicles.Include("Driver.Employee").Include("Vehicle").Where(m => m.Date == dt).ToList();
            //foreach (var transporOrder in TransportOrders)
            //{
            //    foreach (var vehicle in tempVehicles)
            //    {
            //        if ((transporOrder.OrderTranportType == 1 && vehicle.Frozen) ||
            //            (transporOrder.OrderTranportType == 2 && !vehicle.Frozen))
            //            continue;
            //        //int sss=transporOrder.Alt * transporOrder.Ample * transporOrder.Profund ;
            //        //if(transporOrder.Pes < vehicle.MaxWeight && transporOrder.a
            //    }
            //}

            foreach (var transportOrder in TransportOrders)
            {

                foreach (var vehicle in tempVehicles)
                {
                    if (CanVehicleTranportPackage(transportOrder, vehicle.Vehicle))
                    {
                        if (transportOrder.CapableVehicles == null)
                            transportOrder.CapableVehicles = new List<Vehicle>();
                        transportOrder.CapableVehicles.Add(vehicle.Vehicle);

                    }

                }

            }




        }


        #region Step 1

        private void GenerateTransportOrders(List<TransportOrder> TransportOrders)
        {
            var Orders = _db.Orders.Include("Customer")
                                   .Include("OrderDetails")
                                   .Include("OrderDetails.Product")
                                   .Where(m => m.Delivery == null)
                                   .ToList();

            foreach (var order in Orders)
            {
                TransportOrder ot1 = null;
                TransportOrder ot2 = null;

                foreach (var v in order.OrderDetails)
                    AddOrderDetail(ref ot1, ref ot2, v, order);

                if (ot1 != null)
                    TransportOrders.Add(ot1);

                if (ot2 != null)
                    TransportOrders.Add(ot2);

            }
        }

        private void AddOrderDetail(ref TransportOrder ot1, ref TransportOrder ot2, OrderDetail od, Order order)
        {

            if (!od.Product.Refrigerated)
            {
                if (ot1 == null)
                    ot1 = CreateOrderTransport(order, 1);
                ot1.OrderDetails.Add(od);

                ot1.Volume += od.Product.Width * od.Product.Height * od.Product.Depth * od.Quantity;
                ot1.Weight += od.Product.Weight * od.Quantity;
            }
            else
            {
                if (ot2 == null)
                    ot2 = CreateOrderTransport(order, 2);
                ot2.OrderDetails.Add(od);
                ot2.Volume += od.Product.Width * od.Product.Height * od.Product.Depth * od.Quantity;
                ot2.Weight += od.Product.Weight * od.Quantity;
            }
        }

        private TransportOrder CreateOrderTransport(Order order, int type)
        {
            TransportOrder transortOrder = new TransportOrder();
            transortOrder.TranportOrderId = Guid.NewGuid();
            transortOrder.OrderId = order.OrderId;
            transortOrder.OrderTranportType = type;
            transortOrder.Order = order;
            transortOrder.DeliveryDate = null;
            transortOrder.OrderDetails = new List<OrderDetail>();
            return transortOrder;
        }

        #endregion

        #region Step 2

        private void GenerateStoreRoutes(List<TransportOrder> TransportOrders)
        {
            try
            {
                var stores = _db.Stores.Where(m => m.Active == true).ToList();
                List<StoreRoute> StoreRoutes = null;

                foreach (var to in TransportOrders)
                {
                    StoreRoutes = new List<StoreRoute>();
                    foreach (var store in stores)
                    {
                        double Distance = CalculateDistance(to, store, 'M');
                       
                        StoreRoute sr = new StoreRoute();
                        sr.Distance = Distance;
                        sr.StoreRouteId = store.StoreId;
                        sr.Store = store;
                        sr.StoreCapable = CheckStoreCapable(store, to);

                        StoreRoutes.Add(sr);

                    }

                    StoreRoutes.Sort();
                    to.StoreRoutes = new List<StoreRoute>();
                    to.StoreRoutes = StoreRoutes;
                }

            }
            catch (Exception ex)
            {
                Errors.Add("Error al Pas 2" + ex.Message);
            }

        }


        private bool CheckStoreCapable(Store store, TransportOrder to)
        {
            var StocksStore = _db.Stocks.Where(m => m.StoreId == store.StoreId).ToList();

            foreach (var orderDetail in to.OrderDetails)
            {
                var stockStore = StocksStore.Where(m => m.ProductId == orderDetail.ProductId).Select(m => m.Items).FirstOrDefault();

                if (orderDetail.Quantity > stockStore)                
                    return false;                
            }
            return true;
        }

        #endregion

        #region Step 3

        private void GenerateCapablesVehicles(List<TransportOrder> TransporOrders)
        {
            DateTime dt = DateTime.Now.Date;
            var tempVehicles = _db.DriverVehicles.Include("Driver.Employee").Include("Vehicle").Where(m => m.Date == dt).ToList();

            foreach (var transportOrder in TransportOrders)
            {

                foreach (var vehicle in tempVehicles)
                {
                    if (CanVehicleTranportPackage(transportOrder, vehicle.Vehicle))
                    {
                        if (transportOrder.CapableVehicles == null)
                            transportOrder.CapableVehicles = new List<Vehicle>();
                        transportOrder.CapableVehicles.Add(vehicle.Vehicle);

                    }
                }
            }
        }

        private bool CanVehicleTranportPackage(TransportOrder ot, Vehicle vehicle)
        {
            double Volume = 0;
            double Weight = 0;
            if ((ot.OrderTranportType == 1 && vehicle.Refrigerated) ||
                        (ot.OrderTranportType == 2 && !vehicle.Refrigerated))
                return false;

            foreach (var orderDetail in ot.OrderDetails)
            {
                if (orderDetail.Product.Height > vehicle.MaxHeight || orderDetail.Product.Depth > vehicle.MaxDepth
                    || orderDetail.Product.Width > vehicle.MaxWidth)
                    return false;

                Volume += orderDetail.Product.Height * orderDetail.Product.Width * orderDetail.Product.Depth * orderDetail.Quantity;
                Weight += orderDetail.Product.Weight * orderDetail.Quantity;
            }
            if ((Volume > (vehicle.MaxWidth * vehicle.MaxHeight * vehicle.MaxDepth)) || (Weight > vehicle.MaxWeight * 1000))
                return false;
            else
                return true;
        }
       
        #endregion

        #region Step 4

        private List<TransportRoute> CreateTransportRoutes()
        {
            List<TransportRoute> Routes = new List<TransportRoute>();

            DateTime dt = DateTime.Now.Date;
            var driverVehicles = _db.DriverVehicles.Include("Driver.Employee").Include("Vehicle").Where(m => m.Date == dt).ToList();

            foreach (var driverVehicle in driverVehicles)
            {
                TransportRoute TransporRoute = new TransportRoute();
                TransporRoute.TransportRouteId = Guid.NewGuid();
                TransporRoute.Code = Routes.Count + 1;
                TransporRoute.Date = DateTime.Now.Date;
                TransporRoute.Name = "Ruta " + TransporRoute.Code.ToString();
                TransporRoute.Minutes = InitMinutes;
                TransporRoute.StopNumbers = 0;
                TransporRoute.TransportOrder = new List<TransportOrder>();
                TransporRoute.Store = driverVehicle.Vehicle.Store;
                TransporRoute.Latitude = Aux.ConverStringPositionToDouble(driverVehicle.Vehicle.Store.Latitude);
                TransporRoute.Longitude = Aux.ConverStringPositionToDouble(driverVehicle.Vehicle.Store.Longitude);
                TransporRoute.Volume = 0;
                TransporRoute.Weight = 0;
                TransporRoute.Vehicle = driverVehicle;
                Routes.Add(TransporRoute);
            }
            return Routes;           
        }

        #endregion

        #region Step 5


        private void CalculateOrdersRoutes(List<TransportOrder> transportOrders, List<TransportRoute> transporRoutes)
        {
            foreach (var to in TransportOrders)
            {
                GetTimeToRoute(to, TransportRoutes);
            }

        }


        private List<TimeToDestination> GetTimeToRoute(TransportOrder transportOrder, List<TransportRoute> TransportRoutes)
        {
            List<TimeToDestination> DestinationRoutes = new List<TimeToDestination>();
            foreach (var transportRoute in TransportRoutes)
            {
                if (transportOrder.CapableVehicles != null && transportOrder.CapableVehicles.Contains(transportRoute.Vehicle.Vehicle))
                {

                    TimeToDestination Destination = new TimeToDestination();                    
                    Destination.Distance = CalculateDistance(transportOrder, transportRoute, 'M');
                    Destination.TransportRoute = transportRoute;
                    Destination.Time = CalculateSpentTimeToDestination(Destination.Distance, transportRoute.StopNumbers);
                        //Route.Minutes + ((int)(Destination.Distance / VariableTempsDistancia)) + 5 * Route.StopNumbers;
                    //Destination.Time += Route.Minutes;
                    DestinationRoutes.Add(Destination);
                }
            }

            if (DestinationRoutes.Count == 0)
                return null;

            DestinationRoutes.Sort();
            return DestinationRoutes;
        }

        #endregion

        #region Step 6

        private void AssignRoutesToOrders(List<Stock> Stocks)
        {
            while (TransportOrders.Count(m => m.Assigned == false && m.CapableVehicles != null && m.CapableVehicles.Count > 0) > 0)
            {
                foreach (var route in TransportRoutes)
                {
                    List<TimeToDestination> TimeToOrders = GetTimeToOrder(route, TransportOrders);
                    route.NextDestinations = TimeToOrders;
                    if (route.NextDestinations != null && route.NextDestinations.Count > 0)
                    {
                        TimeToDestination ttd = route.NextDestinations.First();//[0];
                        ttd.TransportOrder.Assigned = true;
                        int FinalMinutes = route.Minutes + ttd.Time + AverageTimeStop * route.StopNumbers;
                        ttd.TransportOrder.EstimatedDate = DateTime.Now.Date.AddMinutes(FinalMinutes);
                        route.TransportOrder.Add(ttd.TransportOrder);
                        route.Weight += ttd.TransportOrder.Weight;
                        route.Volume += ttd.TransportOrder.Volume;
                        route.VehicleId = route.Vehicle.VehicleId;
                        route.StopNumbers++;
                        route.Latitude = Aux.ConverStringPositionToDouble(ttd.TransportOrder.Order.Customer.Latitude);
                        route.Longitude = Aux.ConverStringPositionToDouble(ttd.TransportOrder.Order.Customer.Longitude);
                        route.Minutes += ttd.Time;
                        route.NextDestinations = null;
                        
                        foreach (var v in ttd.TransportOrder.OrderDetails)
                        {
                            UpdateProductItems(Stocks, ttd.TransportOrder.OrderDetails, route.Store.StoreId);
                            v.StoreId = route.Store.StoreId;
                        }
                    }
                }
            }


        }

        #endregion


        //Aquesta és una prova
        private List<TimeToDestination> GetTimeToOrder(TransportRoute transportRoute, List<TransportOrder> orderTransports )
        {
            List<TimeToDestination> DestinationOrders = new List<TimeToDestination>();

            foreach (var orderTransport in orderTransports)
            {
                if (orderTransport.Assigned == false && orderTransport.CapableVehicles != null && 
                    orderTransport.CapableVehicles.Contains(transportRoute.Vehicle.Vehicle))
                {
                    TimeToDestination Destination = new TimeToDestination();
                    Destination.Distance = CalculateDistance(orderTransport, transportRoute, 'M');
                    Destination.TransportOrder = orderTransport;
                    Destination.Time = CalculateSpentTimeToDestination(Destination.Distance, transportRoute.StopNumbers);
                    //Route.Minutes + ((int)(Destination.Distance / VariableTempsDistancia)) + 5 * Route.StopNumbers;
                    //Destination.Time += Route.Minutes;
                    DestinationOrders.Add(Destination);
                }


            }
            DestinationOrders.Sort();
            return DestinationOrders;
        }

        private int CalculateSpentTimeToDestination(double distance, int previousStops)
        {
            int TimeToDestination = (int)((distance / VariableTempsDistancia) + (previousStops * AverageTimeStop));
            return TimeToDestination;
        }






        #region Step 7

        private void UpdateProductItems(List<Stock> stocks, List<OrderDetail> orderDetails, Guid storeId)
        {
            foreach (var orderDetail in orderDetails)
            {
                var f = stocks.Where(m => m.StoreId == storeId && m.ProductId == orderDetail.ProductId).FirstOrDefault();
                if (f != null)
                    f.Items += orderDetail.Quantity;
                else
                {

                    Stock stock = new Stock();
                    stock.ProductId = orderDetail.ProductId;
                    stock.StoreId = storeId;
                    stock.Items = orderDetail.Quantity;
                    stocks.Add(stock);
                }
            }
        }

        #endregion

        #region Common

        private double CalculateDistance(TransportOrder ot, TransportRoute ruta, char unit) 
        {
            double latitude1 = double.Parse(ot.Order.Customer.Latitude.Replace(".", ","));
            double longitude1 = double.Parse(ot.Order.Customer.Longitude.Replace(".", ","));

            double latitude2 = ruta.Latitude;
            double longitude2 = ruta.Longitude;

            return CalculateDistance(latitude1, longitude1, latitude2, longitude2, unit);
        
        }

        private double CalculateDistance(TransportOrder ot, Store store, char unit)
        {
            try
            {
                double latitude1 = double.Parse(ot.Order.Customer.Latitude.Replace(".", ","));
                double longitude1 = double.Parse(ot.Order.Customer.Longitude.Replace(".", ","));

                double latitude2 = double.Parse(store.Latitude.Replace(".", ","));
                double longitude2 = double.Parse(store.Longitude.Replace(".", ","));

                return CalculateDistance(latitude1, longitude1, latitude2, longitude2, unit);
            }
            catch (Exception ex)
            {
                Errors.Add("Mètode CalculateDistance:" + ex.Message );
                throw new Exception(ex.Message, ex.InnerException);
            }
        }

        private double CalculateDistance(double latitude1, double longitude1, double latitude2, double longitude2, char unit) 
        {
            double deg2radMultiplier = Math.PI / 180;
            latitude1 = latitude1 * deg2radMultiplier;
            longitude1 = longitude1 * deg2radMultiplier;
            latitude2 = latitude2 * deg2radMultiplier;
            longitude2 = longitude2 * deg2radMultiplier;

            double radius = 6378.137; // earth mean radius defined by WGS84
            double dlon = longitude2 - longitude1;
            double distance = Math.Acos(Math.Sin(latitude1) * Math.Sin(latitude2) + 
                            Math.Cos(latitude1) * Math.Cos(latitude2) * Math.Cos(dlon)) * radius;

            if (double.IsNaN(distance))
                distance=0;

            if (unit == 'K')            
                return (distance);            
            else if (unit == 'M') //    return (distance * 0.621371192);                           
                return (distance * 1000);            
            //else if (unit == 'N')    return (distance * 0.539956803);                                   
            else            
                return 0;           
        }
        #endregion
    }


    public class Aux
    {
        public static double ConverStringPositionToDouble(string position)
        {
            return double.Parse(position.Replace(".", ",")); 
        }
    }
}