﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace NewTravelWebAPI.Models
{
    public class TransportRoute
    {
        [Key]
        public Guid TransportRouteId { get; set; }
        public int Code { get; set; }
        public string Name { get; set; }
        public DateTime Date { get; set; }

        public Guid StoreId { get; set; }
        public Store Store { get; set; }

        public Guid VehicleId { get; set; }
        public DriverVehicle Vehicle { get; set; }

        public int StopNumbers { get; set; }
        public int Minutes { get; set; }

        [NotMapped]
        public double Latitude { get; set; }
        [NotMapped]
        public double Longitude { get; set; }
        [NotMapped]
        public double Volume { get; set; }
        [NotMapped]
        public int Weight { get; set; }

        public virtual List<TransportOrder> TransportOrder { get; set; }

        [NotMapped]
        public virtual List<TimeToDestination> NextDestinations { get; set; }

        [NotMapped]
        public string[] Description { get; set; }



    }
}